import { P as Preset, I as Import, B as BuiltinPresetName, a as PathFromResolver, U as UnimportOptions } from './types-c897d48e';
export { B as BuiltinPresetName, I as Import, c as ImportName, M as ModuleId, a as PathFromResolver, P as Preset, d as PresetImport, U as UnimportOptions, b as builtinPresets } from './types-c897d48e';
import * as MagicString from 'magic-string';
import MagicString__default from 'magic-string';

declare function resolvePreset(preset: Preset): Import[];
declare function resolveBuiltinPresets(presets: (BuiltinPresetName | Preset)[]): Import[];

declare const excludeRE: RegExp[];
declare const importAsRE: RegExp;
declare const separatorRE: RegExp;
declare function defineUnimportPreset(preset: Preset): Preset;
declare function stripCommentsAndStrings(code: string): string;
declare function toImports(imports: Import[], isCJS?: boolean): string;
declare function dedupeImports(imports: Import[], warn: (msg: string) => void): Import[];
declare function toExports(imports: Import[]): string;
declare function toTypeDeclrationItems(imports: Import[], resolvePath?: PathFromResolver): string[];
declare function toTypeDeclrationFile(imports: Import[], resolvePath?: PathFromResolver): string;
declare function addImportToCode(code: string, imports: Import[], isCJS?: boolean, mergeExisting?: boolean): {
    s: MagicString__default;
    code: string;
};
declare function normalizeImports(imports: Import[]): Import[];

declare type Unimport = ReturnType<typeof createUnimport>;
declare function createUnimport(opts: Partial<UnimportOptions>): {
    modifyDynamicImports: (fn: (imports: Import[]) => Promise<void> | void) => Promise<void>;
    getImports: () => Import[];
    detectImports: (code: string) => Promise<{
        strippedCode: string;
        isCJSContext: boolean;
        matchedImports: Import[];
    }>;
    injectImports: (code: string, mergeExisting?: boolean) => Promise<{
        s: MagicString.default;
        code: string;
    }>;
    toExports: () => string;
    generateTypeDecarations: (pathResolver?: PathFromResolver) => string;
};

export { Unimport, addImportToCode, createUnimport, dedupeImports, defineUnimportPreset, excludeRE, importAsRE, normalizeImports, resolveBuiltinPresets, resolvePreset, separatorRE, stripCommentsAndStrings, toExports, toImports, toTypeDeclrationFile, toTypeDeclrationItems };
